.include "m128def.inc"
.def cntr1		= R16
.def cntr2		= R17
.def rx_data 	= R18
.def work0		= R19
.def FLAGREG	= R20
.equ cmd_valid	= 0
.equ cmd_recvd	= 1
.equ startadresse = $0000

;Address LabelsCode Comments
;.org startadresse
jmp RESET ; Reset Handler

.org $0020 + startadresse
jmp TIM0_OVF ; Timer0 Overflow Handler

.org $0024 + startadresse
jmp USART0_RXC ; USART0 RX Complete Handler


.include "uart_com.inc"

RESET:
ldi r16, high(RAMEND); Main program start
out SPH,r16 ; Set stack pointer to top of RAM
ldi r16, low(RAMEND)
out SPL,r16
sei ; Enable interrupts


main:
	rcall init_uart
	sei
	rcall send_reset


txloop:
	sbis UCSR0A,UDRE0
	rjmp txloop
	cpi rx_data, 'r'
	brne txloop
	rjmp jmp2zero
	rjmp txloop


jmp2zero:
	ldi rx_data, 'Z'
wait1:	
	sbis UCSR0A,UDRE0
	rjmp wait1
	out UDR0, rx_data
	jmp $0000
	

TIM0_OVF:
	reti


send_reset:
wt1:
	sbis UCSR0A,UDRE0
	rjmp wt1
	ldi rx_data,'R'
	out UDR0, rx_data
wt2:
	sbis UCSR0A,UDRE0
	rjmp wt2
	ldi rx_data,'e'
	out UDR0, rx_data
wt3:
	sbis UCSR0A,UDRE0
	rjmp wt3
	ldi rx_data,'s'
	out UDR0, rx_data
wt4:
	sbis UCSR0A,UDRE0
	rjmp wt4
	ldi rx_data,'e'
	out UDR0, rx_data
wt5:
	sbis UCSR0A,UDRE0
	rjmp wt5
	ldi rx_data,'t'
	out UDR0, rx_data
wt6:
	sbis UCSR0A,UDRE0
	rjmp wt6
	ldi rx_data,10
	out UDR0, rx_data
wt7:
	sbis UCSR0A,UDRE0
	rjmp wt7
	ldi rx_data,13
	out UDR0, rx_data
ret
